/*!
*****************************************************************************
**
** \file        sys_config.h
**
** \brief       The board configuration for MB86H61.
**
** This file selects the settings for the board configuration.
** It defines all available drivers and their required parameter settings.<br>
** In case of \b Linux environment, it is selected by configuration of
** \b "make menuconfig".<br>
** In case of \b RTOS environment, it is selected by the main configuration file
** "Config.mak".
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH<br>
** (C) Copyright 2008-2010 by Fujitsu Semiconductor Limited
**
*****************************************************************************
*/
#ifndef _FAPEX_CONFIG_H
#define _FAPEX_CONFIG_H

#ifdef CONFIG_FUJITSU_BOARDTYPE_MB86H61_FME_DEVKIT
  #include "fapex/sys_config_mb86h61_devkit.h"
  #define BOARDTYPE_DEFINITION_CHECK
#endif

#ifdef CONFIG_FUJITSU_BOARDTYPE_MB86H61_FMC_DEVKIT
  #include "fapex/sys_config_mb86h61_devkit.h"
  #define BOARDTYPE_DEFINITION_CHECK
#endif

#ifdef CONFIG_FUJITSU_BOARDTYPE_MB86H61_REFSTB
  #include "fapex/sys_config_mb86h61_refstb.h"
  #ifdef BOARDTYPE_DEFINITION_CHECK
  #error Please check the board configuration!
  #else
  #define BOARDTYPE_DEFINITION_CHECK
  #endif
#endif

#endif /* _FAPEX_CONFIG_H */
