/*!
*****************************************************************************
**
** \file        shell.h
**
** \brief       A generic command shell layer
**
** This header file defines the functions of a generic command shell.
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
** (C) Copyright 2008-2010 by Fujitsu Semiconductor Limited
**
*****************************************************************************
*/

#ifndef SHELL_H
    #define SHELL_H

    //***********************************************************************
    //***********************************************************************
    //** Defines and Macros
    //***********************************************************************
    //***********************************************************************


    //***********************************************************************
    //***********************************************************************
    //** Data types
    //***********************************************************************
    //***********************************************************************


    //***********************************************************************
    //***********************************************************************
    //** Global Data
    //***********************************************************************
    //***********************************************************************


    //***********************************************************************
    //***********************************************************************
    //** API Functions
    //***********************************************************************
    //***********************************************************************

    #ifdef __cplusplus
    extern "C" {
    #endif

    uint32_t SHELL_HelpCommand( int32_t argc, char_t* argv[] );
    uint32_t SHELL_HistoryCommand( int32_t argc, char_t* argv[] );
    uint32_t SHELL_RedoCommand( int32_t argc, char_t* argv[] );
    uint32_t SHELL_CursorUpDownCommand( int32_t argc, char_t* argv[] );
    void     SHELL_DoCommand( char_t* command );
    int32_t  SHELL_RegisterCommand( char_t*  command,
                                    uint32_t (*function)(int32_t, char_t**),
                                    char_t*  brief,
                                    char_t*  description );

    #ifdef __cplusplus
    }
    #endif
#endif


