/*!
*****************************************************************************
**
** \file        ./sample_application/fapex_av_demo/src/sidebug.h
** 
** \version     $Id$
**
** \brief       providing terminal output functions for PSI and DVB-SI table parsing.
**
** This file contains the declaration of the scan driver API.
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/

#ifndef SI_DEBUG_H
    #define SI_DEBUG_H

    //***********************************************************************
    //***********************************************************************
    //** API Functions
    //***********************************************************************
    //***********************************************************************

    #ifdef __cplusplus
    extern "C" {
    #endif

    void SI_DEBUG_Pat(uint8_t *data);
    void SI_DEBUG_Cat(uint8_t *data);
    void SI_DEBUG_Pmt(uint8_t *data);
    void SI_DEBUG_Sdt(uint8_t *data);

    void SI_DEBUG_DvbsiConvertSvcType(uint8_t type);
    void SI_DEBUG_PsiStreamType(uint32_t type);

    #ifdef __cplusplus
    }
    #endif
#endif
