/****************************************************************************
* MONTAGE PROPRIETARY AND CONFIDENTIAL
* Montage Technology (Shanghai) Inc.
* All Rights Reserved
* --------------------------------------------------------------------------
*
* File:             mt_fe_example.c
*
* Current version:  0.00.00
*
* Description:      M88DS3000 IC Driver.
*
* Log:  Description             Version     Date        Author
*       ---------------------------------------------------------------------
*
****************************************************************************/
#include "mt_fe_def.h"

#define QUEUE_ID 0x8888



void os_get_mssage(OS_QUEUE queue_id, OS_MESSAGE message, U32 time_out);


typedef enum _MT_FE_OS_STATE
{
    OS_TIMEOUT
}MT_FE_OS_STATE;


typedef enum _MT_FE_STATE
{
    MT_FE_STATE_IDLE
    ,MT_FE_STATE_CONNETED
    ,MT_FE_STATE_CONNETING
}MT_FE_STATE;


typedef enum _MT_FE_CMD
{
    MT_FE_CMD_CONNECT
    ,MT_FE_CMD_GET_CHAN_INFO
    ,MT_FE_CMD_GET_SIGNAL_INFO
    ,MT_FE_CMD_DISEQC_SET_LNB
    ,MT_FE_CMD_DISEQC_SEND_TONE_BURST
    ,MT_FE_CMD_DISEQC_SEND_RECEIVE_MSG
}MT_FE_CMD;

typedef enum _MT_FE_RATATE_DIRECTION
{
    MT_FE_ROTATE_WEST
    ,MT_FE_ROTATE_EAST
}MT_FE_RATATE_DIRECTION;


typedef enum _MT_FE_RATATE_MODE
{
    MT_FE_ROTATE_STEP
    ,MT_FE_ROTATE_CONTINOUS
}MT_FE_RATATE_MODE;




void main(void)
{
    OS_MESSAGE  *message;
    U8          *p_snr;
    U8          *p_strength;
    U8          length;
    U8          data[8];
    U8          switch_port_no, horizontal_polarization;
    U8          direction, rotate_mode;
    S32         ret;
    U32         state;
    U32         cnt;
    U32         freq_MHz;
    U32         sym_rate_KSs;
    U32         *p_total_packags, *p_err_packags;
    BOOL        lnb_on_off, on_off_22k;
    MT_FE_LNB_VOLTAGE   choice_13v_18v;
    MT_FE_LOCK_STATE lock_state = MT_FE_STATE_IDLE;
    MT_FE_CHAN_INFO_DVBS2 chan_info;
    MT_FE_TYPE  dvbs_type;
    MT_FE_DiSEqC_MSG msg;
    MT_FE_DiSEqC_TONE_BURST mode;




    mt_fe_dmd_ds3k_init();


    while (1)
    {
        ret = os_get_mssage(QUEUE_ID, message, 100) /*  timeout = 100ms */

        if (ret == OS_TIMEOUT)
        {
            switch (state)
            {
                case MT_FE_STATE_CONNETING:
                    mt_fe_dmd_ds3k_get_lock_state(&lock_state);


                    if (lock_state == MtFeLockState_Locked)
                    {
                        /* change state */
                        state = MT_FE_STATE_CONNETED;

 
                        /*
                            TODO:
                                send message to APP, that demodulater has Locked !

                                call function 'mt_fe_dmd_get_chan_info_code_dd2k' to
                                get the chan_info_code, and send it to APP.
                        */
                        mt_fe_dmd_ds3k_get_channel_info(chan_info);


                        cnt = 0;
                        break;
                    }
                    else if (lock_state == MtFeLockState_Unlocked)
                    {
                        cnt++;
                    }
                    else if (lock_state == MtFeLockState_Waiting)
                    {
                        cnt++;
                    }


                    if (cnt > 70)
                    {
                        /*
                            TODO:
                                send message to APP, that demodulater Unlock !
                        */


                        /*  re-connect  */
                        mt_fe_dmd_ds3k_connect(freq_MHz, sym_rate_KSs, dvbs_type);

                        /*  if unlock, reset cnt  */
                        cnt = 0;
                    }
                    break;

                case MT_FE_STATE_CONNETED:
                    mt_fe_dmd_ds3k_get_lock_state(&lock_state);

                    if (lock_state == MtFeLockState_Locked)
                        cnt = 0;
                    else
                        cnt ++;

                    if (cnt > 10)
                    {
                        /*
                            TODO:
                                send message to APP, that demodulater Drop !
                        */


                        /*  change state    */
                        state = MT_FE_STATE_CONNETING;

                        /*  re-connect  */
                        mt_fe_dmd_ds3k_connect(freq_MHz, sym_rate_KSs, dvbs_type);

                        /*  if drop, reset chan_info_code   */
                        cnt = 0;
                    }
                    break;

                case MT_FE_STATE_IDLE:
                default:
                    break;
            }

            continue;
        }


        switch(message)
        {
            case MT_FE_CMD_CONNECT:
                /*
                Get frequency and symbol rate and dvb_type from app.

                1.  frequency------- UNIT: MHz
                2.  symbol rate----- UNIT: KSs
                3.  dvbs_type-------- may be the three types:
                
                        "MtFeType_DvbS"
                        "MtFeType_DvbS2"
                        "MtFeType_DvbS_Unknown"
                        
                    If you do not know the modulator mode, you can set the dvbs_type as "MtFeType_DvbS_Unknown".
                It will try DVBS and DVBS2 mode automatically.*/
                freq_MHz       = ??;
                sym_rate_KSs   = ??;
                dvbs_type      = ??;

                mt_fe_dmd_ds3k_connect(freq_MHz, sym_rate_KSs, dvbs_type);


                state = MT_FE_STATE_CONNETING;
                cnt   = 0;
                break;


            case MT_FE_CMD_GET_CHAN_INFO:
                /*
                    TODO:
                        call function 'mt_fe_dmd_ds3k_get_channel_info' to
                        get the channel infomation, and send it to APP.
                        pls see structure MT_FE_CHAN_INFO_DVBS2
                */
                mt_fe_dmd_ds3k_get_channel_info(&chan_info);
                break;

            case MT_FE_CMD_GET_SIGNAL_INFO:
                /*
                    TODO:
                        1. call 'mt_fe_dmd_ds3k_get_snr' to get the signal quality,
                        2. call 'mt_fe_dmd_ds3k_get_per' to get the error packages and total packages
                            to calculate the per.
                        3. call 'mt_fe_dmd_ds3k_get_strength' to get the signal strength

                    You can use these APIs to send the signal infomatio to APP.
                */

                mt_fe_dmd_ds3k_get_lock_state(&lock_state);

                if(lock_state == MtFeLockState_Locked)
                {
                    mt_fe_dmd_ds3k_get_snr(&p_snr);
                    mt_fe_dmd_ds3k_get_strength(&p_strength);

                    /*In DVBS2 mode, get PER value; DVBS mode gets the BER value*/
                    mt_fe_dmd_ds3k_get_per(&p_total_packags, &p_err_packags);
                }
                else
                {
                    p_snr = 0;
                    p_strength = 0;
                    p_err_packags = 0;          /*indicate error bit in DVBS mode*/
                    p_total_packags = 0xffff;   /*indicate total bits in DVBS mode*/
                }
                break;


            case MT_FE_CMD_DISEQC_SET_LNB:
                /*
                    TODO:
                        You can call API 'mt_fe_dmd_ds3k_set_LNB' to set LNB on and select the LNB voltage
                    according to the designed circuit.*/

                 lnb_on_off     = MtFe_True;
                 on_off_22k     = MtFe_True;
                 choice_13v_18v = MtFeLNB_18V;
        
                 mt_fe_dmd_ds3k_set_LNB(lnb_on_off, on_off_22k, choice_13v_18v);

                break;


            case MT_FE_CMD_DISEQC_SEND_TONE_BURST:

                mode = MtFeDiSEqCToneBurst_Moulated;

                mt_fe_dmd_ds3k_DiSEqC_send_tone_burst(mode);
                break;


            case MT_FE_CMD_DISEQC_SEND_RECEIVE_MSG:

                /* 1. DiSEqC switch control application example */
                
                switch_port_no          = ??;   /*switch port*/
                horizontal_polarization = ??;   /*polarization voltage*/
                on_off_22k              = ??;   /*22k signal on/off*/


                /* STEP1: LNB on, 22K off, 18V/13V */
                mt_fe_dmd_ds3k_set_LNB(MtFe_True, MtFe_False, MtFeLNB_18V/MtFeLNB_13V);
                
                /* STEP2: Send DiSEqC Message */
                /*maybe the one or more message byte(s) should be modified with some DiSEqC switches*/
                msg.data_send[0] = 0xE0; /*Framing Byte*/
                msg.data_send[1] = 0x10; /*Address Byte*/
                msg.data_send[2] = 0x38; /*Command Byte*/
                msg.data_send[3] = 0xF0 + (switch_port_no - 1)*4; /*Data Byte*/
                
                if(horizontal_polarization == MtFeLNB_18V)  msg.data_send[3] |= 0x02; /*Bit 1 set 1*/ 
                if(on_off_22k == MtFe_True)                 msg.data_send[3] |= 0x01; /*Bit 0 set 1*/ 
                /*only send data to device*/
                msg.is_enable_receive = FALSE;
                mt_fe_dmd_ds3k_DiSEqC_send_receive_msg(msg);
                
                /*STEP3: LNB on, 22K on, 18V/13V, Maybe this step is not necessary if needn't set 22K signal on*/
                /*LNB on, 22K on, 18V/13V*/
                mt_fe_dmd_ds3k_set_LNB(MtFe_True, MtFe_False, MtFeLNB_18V/MtFeLNB_13V);

                /*STEP4: Connect the TP*/
                mt_fe_dmd_ds3k_connect(freq_MHz, sym_rate_KSs, dvbs_type);

                /* 2. DiSEqC Motor Rotation control application*/

                direction   = MT_FE_ROTATE_EAST ? 0x68 : 0x69; /*rotate direction*/
                rotate_mode = MT_FE_ROTATE_STEP ? 0xFF : 0x00; /*rotate mode*/

                /*2.1 Motor Rotation Start*/
                /* maybe the one or more message byte(s) should be modified with some DiSEqC motors*/
                msg.data_send[0] = 0xE0;        /*Framing Byte*/
                msg.data_send[1] = 0x31;        /*Address Byte*/
                msg.data_send[2] = direction;   /*Command Byte1*/
                msg.data_send[3] = rotate_mode; /*Command Byte2*/

                /*only send data to device*/
                msg.is_enable_receive = FALSE;
                
                mt_fe_dmd_ds3k_DiSEqC_send_receive_msg(msg);

                /*2.2 Motor Rotation Stop*/
                /* maybe the one or more message byte(s) should be modified with some DiSEqC motors*/
                msg.data_send[0] = 0xE0;        /*Framing Byte*/
                msg.data_send[1] = 0x31;        /*Address Byte*/
                msg.data_send[2] = 0x60;        /*Command Byte*/

                /*only send data to device*/
                msg.is_enable_receive = FALSE;
                
                mt_fe_dmd_ds3k_DiSEqC_send_receive_msg(msg);


                break;

                
            default:
                break;
        }
    }
}


















