/******************************************************************************

File Name:   MB86667_Scan.h
Copyright:   (C) Fujitsu Semiconductor Europe 2007

             THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
             ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
             OMMISSIONS.

Description: This header file contains all publics (structures,
             Constants, function prototypes, ...) of the qst scan driver module


Copyright:
   $(c) 2007 Fujitsu Semiconductor Europe GmbH

******************************************************************************/
#ifndef _MB86667_SCAN_H_
#define _MB86667_SCAN_H_

/*---------------------------------------------------------------------------*/
/* local defines                                                             */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* constants and macros                                                      */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* types, enums and structures                                               */
/*---------------------------------------------------------------------------*/
typedef struct
{
    uint32_t                    startFrequency;  /* in  KHz */
    uint32_t                    stopFrequency;   /* in  KHz */
    uint16_t                    startSymbolRate; /* in  KS/s */
    uint16_t                    stopSymbolRate;  /* in  KS/s */
    uint8_t                     pol;  /* refer to enum in MB86667_Api.h */
    uint8_t                  (*feScanAbortFct)();
    void                   (*feScanProgressFct)(uint16_t progress);
    void                   (*feScanNotifyFct)(FE_TUNE_PARAMS_S* pTuneFoundParams); //MB86667_TRANSPONDER_T* pFoundTransponder
} MB86667_SCAN_PARAMS_T;

/*---------------------------------------------------------------------------*/
/* function prototypes                                                       */
/*---------------------------------------------------------------------------*/
#ifdef __cplusplus
extern "C" {
#endif

int32_t MB86667_Scan(MB86667_SCAN_PARAMS_T *pScanParams, MB86667_SATELLITE_T* pSatType);

#ifdef __cplusplus
}
#endif

#endif /* _MB86667_SCAN_H_ */
/* end of MB86667_Scan.h */

