/*******************************************************************************
**
** \file      ./subsystems/fe/mb86667/src/MB86667_Tuner.h
**
** \brief     Tuner Driver for MB86667.
**
**            (C) Fujitsu Semiconductor Europe 2006 - 2007
**
** \attention THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**            ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**            OMMISSIONS.
**
** \version   $Id: MB86667_Tuner.h 1911 2009-02-02 10:17:47Z wlaris $
**
******************************************************************************/
#ifndef _MB86667_TUNER_H_
#define _MB86667_TUNER_H_

#include "MB86667_Api.h"

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------*/
/* typedefs                                                                  */
/*---------------------------------------------------------------------------*/
typedef int32_t (*FE_MB86667_RF_INI_FCT_T)(uint32_t f10, uint16_t smrt);
typedef int32_t (*FE_MB86667_RF_SET_FCT_T)(uint32_t f10, uint16_t smrt);

/*---------------------------------------------------------------------------*/
/* function prototypes                                                       */
/*---------------------------------------------------------------------------*/
int32_t MB86667_Rf_Val_Set_Ini_S7HZ1402(uint32_t f10, uint16_t smrt);
int32_t MB86667_Rf_Val_Set_S7HZ1402(uint32_t f10, uint16_t smrt);
int32_t MB86667_Rf_Val_Set_Ini_MAX2118(uint32_t f10, uint16_t smrt);
int32_t MB86667_Rf_Val_Set_MAX2118(uint32_t f10, uint16_t smrt);

#ifdef __cplusplus
}
#endif


#endif /* _MB86667_TUNER_H_ */
/* end of MB86667_Tuner.h */

