/******************************************************************************
**
** \file      ./subsystems/fe/mb86668/src/mb86668_fe_c.h
**
** \brief     Driver for Fujitsu MB86667.
**
**            (C) Fujitsu Semiconductor Europe 2002 - 2007
**
** \attention THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**            ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**            OMMISSIONS.
**
** \version   \$Id: mb86668_fe_c.h 1911 2009-02-02 10:17:47Z wlaris $
**
******************************************************************************/

#ifndef _FD_MB86668_FE_C_H_
#define _FD_MB86668_FE_C_H_

#include "mb86668_demod.h"
#include "mb86668_tuner_c.h"



#define RF_AGC_EXT 0x60
#define RF_AGC_M3  0x20
#define RF_AGC_M6  0x30

// frontend device structure
typedef struct
{
   TUN_device Tuner;
   DEM_device Demod;
} FEC_device;


FeErr TUN_C_TestDevice(FEC_device * handle);
FeErr TUN_C_init(FEC_device * handle);
FeErr TUN_C_setFrequency(FEC_device * handle, uint32_t frequency, uint32_t *newFrequency);

FeErr DEM_86668_openRepeater(FEC_device * handle);
FeErr DEM_86668_closeRepeater(FEC_device * handle);
FeErr DEM_86668_TestDevice(FEC_device * handle);
FeErr DEM_86668_Init(FEC_device * handle);
FeErr DEM_86668_SearchTransponder(FEC_device * handle, FE_86668_SearchParams_t *pSearch);
FeErr DEM_86668_GetLock(FEC_device * handle,uint8_t *pStatus);
FeErr DEM_86668_GetAgc(FEC_device * handle,uint16_t *pAgc);
FeErr DEM_86668_GetCN(FEC_device * handle,uint32_t *pNoise);
FeErr DEM_86668_GetBer(FEC_device * handle, uint32_t *pBer);
FeErr DEM_86668_GetCarrierOffset(FEC_device * handle, uint32_t *pOffset);


#endif // _FD_MB86668_FE_C_H_



