#!/bin/sh

CP='/bin/cp -p'
LN=/bin/ln
CD=cd
MV=mv

PWD=/bin/pwd

TOPDIR=`${PWD}`
INCDIR=${TOPDIR}/include
LIBDIR=${TOPDIR}/lib

${CP} ${TOPDIR}/Makefile_Linux ${TOPDIR}/Makefile
${CP} ${TOPDIR}/audio/Makefile_Linux ${TOPDIR}/audio/Makefile
${CP} ${TOPDIR}/audio/aal/Makefile_Linux ${TOPDIR}/audio/aal/Makefile
${CP} ${TOPDIR}/Makefile_Linux ${TOPDIR}/Makefile
${CP} ${TOPDIR}/fe/Makefile_Linux ${TOPDIR}/fe/Makefile
#${CP} ${TOPDIR}/flashfs/Makefile_Linux ${TOPDIR}/flashfs/Makefile
${CP} ${TOPDIR}/paint/Makefile_Linux ${TOPDIR}/paint/Makefile
${CP} ${TOPDIR}/paint/draw/Makefile_Linux ${TOPDIR}/paint/draw/Makefile
${CP} ${TOPDIR}/paint/freetype2/Makefile_Linux ${TOPDIR}/paint/freetype2/Makefile
${CP} ${TOPDIR}/paint/fontserver/Makefile_Linux ${TOPDIR}/paint/fontserver/Makefile
${CP} ${TOPDIR}/paint/fontserver/engines/Makefile_Linux ${TOPDIR}/paint/fontserver/engines/Makefile
${CP} ${TOPDIR}/paint/fontserver/engines/fbf/Makefile_Linux ${TOPDIR}/paint/fontserver/engines/fbf/Makefile
${CP} ${TOPDIR}/paint/fontserver/engines/freetype/Makefile_Linux ${TOPDIR}/paint/fontserver/engines/freetype/Makefile
${CP} ${TOPDIR}/paint/osdhandler/Makefile_Linux ${TOPDIR}/paint/osdhandler/Makefile
${CP} ${TOPDIR}/paint/jpeg/Makefile_Linux ${TOPDIR}/paint/jpeg/Makefile
${CP} ${TOPDIR}/paint/PNG/Makefile_Linux ${TOPDIR}/paint/PNG/Makefile
${CP} ${TOPDIR}/video/Makefile_Linux ${TOPDIR}/video/Makefile
${CP} ${TOPDIR}/video/val/Makefile_Linux ${TOPDIR}/video/val/Makefile
${CP} ${TOPDIR}/sfal/Makefile_Linux ${TOPDIR}/sfal/Makefile

${LN} -s ${TOPDIR}/audio/aal/src/aal.h          ${INCDIR}/aal/.
${LN} -s ${TOPDIR}/compression/libz/src/zlib.h  ${INCDIR}/compression/.
${LN} -s ${TOPDIR}/compression/libz/src/zconf.h ${INCDIR}/compression/.
${LN} -s ${TOPDIR}/fe/src/fe.h ${INCDIR}/fe/.
${LN} -s ${TOPDIR}/fe/src/fe_priv.h ${INCDIR}/fe/.
${LN} -s ${TOPDIR}/fs/fatfs/include/api_f.h      ${INCDIR}/fatfs/.
${LN} -s ${TOPDIR}/fs/fatfs/include/atadrv.h     ${INCDIR}/fatfs/.
${LN} -s ${TOPDIR}/fs/fatfs/include/cutcluster.h ${INCDIR}/fatfs/.
${LN} -s ${TOPDIR}/fs/fatfs/include/fatfs.h      ${INCDIR}/fatfs/.
${LN} -s ${TOPDIR}/fs/fatfs/include/flashdrv.h   ${INCDIR}/fatfs/.
${LN} -s ${TOPDIR}/fs/fatfs/include/fwerr.h      ${INCDIR}/fatfs/.
${LN} -s ${TOPDIR}/fs/fatfs/include/mmcsddrv.h   ${INCDIR}/fatfs/.
${LN} -s ${TOPDIR}/fs/fatfs/include/usbdrv.h     ${INCDIR}/fatfs/.
${LN} -s ${TOPDIR}/fs/flashfs/src/flashfs.h      ${INCDIR}/flashfs/.
${LN} -s ${TOPDIR}/paint/draw/src/draw.h ${INCDIR}/draw/.
${LN} -s ${TOPDIR}/paint/fbf/src/fbf_zwo_bold.h ${INCDIR}/fbf/.
${LN} -s ${TOPDIR}/paint/fontserver/src/fontserver.h                            ${INCDIR}/fontserver/.
${LN} -s ${TOPDIR}/paint/fontserver/src/fontserver_engine.h                     ${INCDIR}/fontserver/.
${LN} -s ${TOPDIR}/paint/fontserver/src/fontserver_shared.h                     ${INCDIR}/fontserver/.
${LN} -s ${TOPDIR}/paint/fontserver/engines/fbf/src/fontserver_engine_fbf.h     ${INCDIR}/fontserver/.
${LN} -s ${TOPDIR}/paint/fontserver/engines/freetype/src/fontserver_engine_ft.h ${INCDIR}/fontserver/.
${LN} -s ${TOPDIR}/paint/freetype2/include/freetype ${INCDIR}/freetype
${LN} -s ${TOPDIR}/paint/freetype2/include/ft2build.h ${INCDIR}/freetype/ft2build.h
${LN} -s ${TOPDIR}/paint/osdhandler/src/osdhandler.h ${INCDIR}/osdhandler/.
${LN} -s ${TOPDIR}/paint/osdhandler/src/osdhandler_fb.h ${INCDIR}/osdhandler/.
${LN} -s ${TOPDIR}/paint/ftf/src/ftf.h ${INCDIR}/ftf/.
${LN} -s ${TOPDIR}/paint/jpeg/src/jdct.h         ${INCDIR}/jpeg/.
${LN} -s ${TOPDIR}/paint/jpeg/src/jdhuff.h       ${INCDIR}/jpeg/.
${LN} -s ${TOPDIR}/paint/jpeg/src/jinclude.h     ${INCDIR}/jpeg/.
${LN} -s ${TOPDIR}/paint/jpeg/src/jmemsys.h      ${INCDIR}/jpeg/.
${LN} -s ${TOPDIR}/paint/jpeg/include/jmorecfg.h ${INCDIR}/jpeg/.
${LN} -s ${TOPDIR}/paint/jpeg/include/JPEG_api.h ${INCDIR}/jpeg/.
${LN} -s ${TOPDIR}/paint/jpeg/include/jpegint.h  ${INCDIR}/jpeg/.
${LN} -s ${TOPDIR}/paint/jpeg/include/jpeglib.h  ${INCDIR}/jpeg/.
${LN} -s ${TOPDIR}/paint/PNG/src/png.h     ${INCDIR}/png/.
${LN} -s ${TOPDIR}/paint/PNG/src/pngconf.h ${INCDIR}/png/.
${LN} -s ${TOPDIR}/video/val/src/val.h     ${INCDIR}/val/.
${LN} -s ${TOPDIR}/subtitle/include/DsubDisplayDriver.h  ${INCDIR}/subtitle/.
${LN} -s ${TOPDIR}/subtitle/include/DsubStddef.h         ${INCDIR}/subtitle/.
${LN} -s ${TOPDIR}/subtitle/include/DsubTClut.h          ${INCDIR}/subtitle/.
${LN} -s ${TOPDIR}/subtitle/include/DsubTDecoder.h       ${INCDIR}/subtitle/.
${LN} -s ${TOPDIR}/subtitle/include/DsubTDecoderTypes.h  ${INCDIR}/subtitle/.
${LN} -s ${TOPDIR}/subtitle/include/DsubTDisplayDriver.h ${INCDIR}/subtitle/.
${LN} -s ${TOPDIR}/teletext/include/TT_Aci.h           ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_AciDecoder.h    ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_ACQ.h           ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_Charset.h       ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_Core.h          ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_Database.h      ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_Decoder.h       ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_Display.h       ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_DriverDisplay.h ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_DriverFont.h    ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_Global.h        ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_Key.h           ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_PacketBuffer.h  ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_Queue.h         ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_Stdinc.h        ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/teletext/include/TT_TOP.h           ${INCDIR}/teletext/.
${LN} -s ${TOPDIR}/sfal/src/sfal.h     ${INCDIR}/sfal/.

${MV} ${TOPDIR}/paint/fbf/libfbf.so paint/fbf/libfbf.so.0.1
${MV} ${TOPDIR}/paint/ftf/libftf.so paint/ftf/libftf.so.0.1

${LN} -s ${TOPDIR}/paint/fbf/libfbf.a        ${LIBDIR}/.
${LN} -s ${TOPDIR}/paint/fbf/libfbf.so.0.1   ${LIBDIR}/libfbf.so
${LN} -s ${TOPDIR}/paint/ftf/libftf.a        ${LIBDIR}/.
${LN} -s ${TOPDIR}/paint/ftf/libftf.so.0.1   ${LIBDIR}/libftf.so
${LN} -s ${TOPDIR}/subtitle/libsubtitle.a    ${LIBDIR}/.
${LN} -s ${TOPDIR}/teletext/libteletext.a    ${LIBDIR}/.
${LN} -s ${TOPDIR}/dsf89000/libdsf89000.a ${LIBDIR}/.
