/*!
*****************************************************************************
**
** \file        ./subsystems/paint/freetype2/src/fontnotify.c
** 
** \version     $Id: fontnotify.c 1911 2009-02-02 10:17:47Z wlaris $
**
** \brief       FONT Driver FreeType notification mechanism
**
** This file contains the implementation of the FONT driver FreeType
** notification mechanism API for the case that FreeType IS present.
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2007 - 2008 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/

#include <font/font_ft_notify.h>

//***************************************************************************
//***************************************************************************
//** API Functions
//***************************************************************************
//***************************************************************************

/*!
*****************************************************************************
** \brief   Notify the FONT driver that the FreeType library is present.
*****************************************************************************
*/
void FONT_FreeTypeNotify(void)
{
    fontFreeTypeAvailable = 1;
}
