/*!
*****************************************************************************
**
** \file        ./applications/smartgo-hd/app_ref/inc/app_menu_info.h
**
**              $Id: app_menu_info.h 5866 2010-03-02 12:09:31Z jmorha $
**
** \brief       Public functions of OSD info module.
**
** Detail description. [\ref app_smartgo_app_ref_info]
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/
#ifndef _APP_MENU_INFO_H_
#define _APP_MENU_INFO_H_

#include "sys_api.h"

#ifdef __cplusplus
extern "C" {
#endif

void            MAIN_SelectServiceByInput        (void);

void            MENU_InfoServSelectTimerExpired  (void);
void            MENU_InfoUpdateService           (void);
void            MENU_InfoUpdateAudioLanguage     (void);
void            MENU_InfoEitUpdate               (SLIST_SERVIDX servIdx);
void            MENU_InfoUpdateSched             (SLIST_SERVIDX servIdx);
void            MENU_InfoUpdatePicFormat         (SYS_PICFORMAT_E newFormat);
void            MENU_InfoUpdateLockStatus        (uint8_t feNum,
                                                  SYS_FE_LOCK_E status);
FSTATIC void            MENU_InfobarUpdateServiceSymbols (void);
void            MENU_InfoUpdateParentalLockStatus(void);

void            MENU_InfoTimeBoxGetItem          (FAPI_SYS_HandleT h,
                                                  int32_t id,
                                                  uint32_t index,
                                                  FGS_ITEMSTATE_E state,
                                                  FGS_ITEM_S* item);
void            MENU_InfoListSymbolBoxGetItem    (FAPI_SYS_HandleT h,
                                                  int32_t id,
                                                  uint32_t index,
                                                  FGS_ITEMSTATE_E state,
                                                  FGS_ITEM_S* item);
void            MAIN_ServiceNumGetItem           (FAPI_SYS_HandleT h,
                                                  int32_t id,
                                                  uint32_t index,
                                                  FGS_ITEMSTATE_E state,
                                                  FGS_ITEM_S* item);
void            MENU_InfoServiceNameBoxGetItem   (FAPI_SYS_HandleT h,
                                                  int32_t id,
                                                  uint32_t index,
                                                  FGS_ITEMSTATE_E state,
                                                  FGS_ITEM_S* item);

SYS_SERVLOC_S*  MENU_InfoGetCurrServLoc          (void);
fbool_t         MENU_InfoIsInputMode             (void);
#ifdef APPL_SUBTT_ENABLED
fbool_t         MENU_InfoIsSubtitleAvl           (void);
#endif

#ifdef APPL_MHEG_ENABLED
fbool_t         MENU_InfoIsMhegAvl               (void);
#endif

fbool_t         MENU_InfoIsTeletextAvl           (void);
fbool_t         MENU_InfoIsCrypted               (void);
fbool_t         MENU_InfoIs16_9                  (void);
fbool_t         MENU_InfoIsHD                    (void);
#ifdef APPL_PARENTAL_ENABLED
fbool_t         MENU_InfoIsLocked                (void);
#endif

#ifdef APPL_PVR_ENABLED
SYS_TIME_S*     MENU_InfoGetPlayTime             (void);
SYS_TIME_S*     MENU_InfoGetRecTime              (int8_t recIdx);
void            MENU_InfoUpdatePvrStatus         (PVRSYS_STATUS_S* newStatus);
#endif /* APPL_PVR_ENABLED */


void            MENU_InfobarUpdateCurrNext       (void);
void            MENU_InfobarUpdateAudio          (void);
void            MENU_InfobarUpdateWideSymbol     (void);
void            MENU_InfobarUpdateProgressbar    (void);
#ifdef APPL_PARENTAL_ENABLED
void            MENU_InfobarUpdateLockedIcon     (void);
#endif

#ifdef APPL_PVR_ENABLED
void            MENU_InfobarUpdatePlayTime       (fbool_t force);
void            MENU_InfobarUpdateRecStatus      (fbool_t force);
#endif
void            MENU_InfobarUpdateDisplayTimer   (void);


#ifdef __cplusplus
}
#endif

#endif /* _APP_MENU_INFO_H_ */
/******************************************************************************/
/* END OF FILE */
