/*!
*****************************************************************************
**
** \file        ./applications/smartgo-hd/app_ref/inc/app_menu_scan.h
**
**              $Id: app_menu_scan.h 5866 2010-03-02 12:09:31Z jmorha $
**
** \brief       Scanning menu
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/
#ifndef _APP_MENU_SCAN_H_
#define _APP_MENU_SCAN_H_

/*---------------------------------------------------------------------------*/
/* constants and macros                                                      */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* types, enums and structures                                               */
/*---------------------------------------------------------------------------*/

enum
{
    MENU_SCANMETHOD_AUTO = 0,
    MENU_SCANMETHOD_SINGLE,
    //MENU_SCANMETHOD_MANUAL,
    #ifdef APPL_BLINDSCAN_ENABLED
    MENU_SCANMETHOD_BLIND,
    #endif
    //MENU_SCANMETHOD_CURRTS,
    MENU_SCANMETHOD_NUMS
};

typedef struct
{
    FE_SYSTEM_TYPE_E    system;       //!< scan menu system
    CHANREGION_E        region;       //!< for terrestrial system only
    CABLEPRESET_E       cabNetwork;   //!< for cable systems only
    uint8_t             method;       //!< scan mode: auto, single or manual
    AV_SCAN_OPTS_S      opts;         //!< scan option settings
    SYS_NETWORK_S       network;      //!< current network
    uint16_t            tpLstPos;     //!< carrier index in current network

} MENU_SCAN_CFG_S;

/*---------------------------------------------------------------------------*/
/* function prototypes                                                       */
/*---------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

void  MENU_ScanUpdateLockStatus (uint8_t feNum, SYS_FE_LOCK_E status);

void  MENU_ScanningProgress     (SYS_EVT_SCAN_S* stat);
void  MENU_ScanningServAdded    (SYS_EVT_SERVICE_S* serv);
void  MENU_ScanningCarrierAdded (SYS_EVT_CARRIERADD_S* chanadd);

#ifdef __cplusplus
}
#endif

#endif /* _APP_MENU_SCAN_H_ */
/******************************************************************************/
/* END OF FILE */
