/*!
*****************************************************************************
**
** \file        ./applications/smartgo-hd/app_ref/inc/app_satellites.h
**
**              $Id: app_satellites.h 5866 2010-03-02 12:09:31Z jmorha $
**
** \brief       default satellite/carrier definitions.
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/
#ifndef _APP_SATELLITES_H_
#define _APP_SATELLITES_H_

/*---------------------------------------------------------------------------*/
/* constants and macros                                                      */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* types, enums and structures                                               */
/*---------------------------------------------------------------------------*/

typedef enum
{
    SATID_HOTBIRD = 0,
    SATID_ASTRA,
    SATID_EUTELSAT_W2,
    SATID_EUTELSAT_W1,
    SATID_EUTELSAT_W3A,
    SATID_SIRIUS,
    SATID_TELECOM_2C,
    SATID_INTELSAT_10_02,
    SATID_ATLANTIC_BIRD_3,
    SATID_ATLANTIC_BIRD_2,
    SATID_INTELSAT_907,
    SATID_HISPASAT_1C_1D,
    SATID_ASTRA_1D_3A,
    SATID_ARABSAT,
    SATID_EUROBIRD_1,
    SATID_ASTRA_2,
    SATID_ARABSAT_2B,
    SATID_EUROBIRD_3,
    SATID_TURKSAT_1C,
    SATID_EUTELSAT_SESAT,
    SATID_PAS_1_R,
    SATID_THOR,
    SATID_NILESAT,
    SATID_ATLANTIC_BIRD_1,
    SATID_NUMS

} APP_SATID_E;

typedef struct
{
    APP_SATID_E         id;
    const char_t*       name;
    int32_t             networkId;
    uint16_t            orbitalPosition;
    FE_WE_FLAG_E        westEastFlag;

    TUNE_ITEM_SAT_S*    pCarrier;

} APP_SATPAR_S;

extern APP_SATPAR_S satLst[];

/*---------------------------------------------------------------------------*/
/* function prototypes                                                       */
/*---------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
}
#endif

#endif /* _APP_SATELLITES_H_ */
/******************************************************************************/
/* END OF FILE */
