################################################################################
################################################################################
##
## Makefile -- project specific makefile to build an executable
##
## (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
##
##      THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
##      ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
##      OMMISSIONS.
##
## Version: $Id: Makefile 5833 2010-02-26 11:13:03Z kchen $
##
## Description: Application-specific makefile extensions for SmartGo.
##
################################################################################
################################################################################

################################################################################
# Miscellaneous switches
################################################################################

# Optional main menu with full-screen bitmap picture in background
#CCFLAGS_USER += -DFULLSCREEN_MAINMENU

# Usage of graphics in "satellite installation type" menu
#CCFLAGS_USER += -DUSE_SATINST_GFX

# Playing of audio "welcome jingle" at startup
#CCFLAGS_USER += -DPLAY_WELCOME_JINGLE

################################################################################
# Internal area - Do not modify!
################################################################################

  SOURCES += $(APPPATH)/src/app_main.c
  SOURCES += $(APPPATH)/src/app_osd.c
  SOURCES += $(APPPATH)/src/app_items.c
  SOURCES += $(APPPATH)/src/app_confdialog.c
  SOURCES += $(APPPATH)/src/app_directfunctions.c
  SOURCES += $(APPPATH)/src/app_streamselect.c
  SOURCES += $(APPPATH)/src/app_menustack.c
  SOURCES += $(APPPATH)/src/app_lang.c
  SOURCES += $(APPPATH)/src/app_servbox.c
  SOURCES += $(APPPATH)/src/app_guided.c

  SOURCES += $(APPPATH)/src/app_menu_antenna_program.c
  SOURCES += $(APPPATH)/src/app_menu_audio_video.c
  SOURCES += $(APPPATH)/src/app_menu_common.c
  SOURCES += $(APPPATH)/src/app_menu_editstring.c
  SOURCES += $(APPPATH)/src/app_menu_info.c
  SOURCES += $(APPPATH)/src/app_menu_infobar.c
  SOURCES += $(APPPATH)/src/app_menu_epg_grid.c
  SOURCES += $(APPPATH)/src/app_menu_epg_ext.c
  SOURCES += $(APPPATH)/src/app_menu_epg_sched.c
  SOURCES += $(APPPATH)/src/app_menu_information.c
  SOURCES += $(APPPATH)/src/app_menu_language.c
  SOURCES += $(APPPATH)/src/app_menu_main.c
  SOURCES += $(APPPATH)/src/app_menu_osd.c
  SOURCES += $(APPPATH)/src/app_menu_scan.c
  SOURCES += $(APPPATH)/src/app_menu_scanning.c
  SOURCES += $(APPPATH)/src/app_menu_servlist.c
  SOURCES += $(APPPATH)/src/app_menu_servselect.c
  SOURCES += $(APPPATH)/src/app_menu_streaminfo.c
  SOURCES += $(APPPATH)/src/app_menu_systemsetup.c
  SOURCES += $(APPPATH)/src/app_menu_time.c
  SOURCES += $(APPPATH)/src/app_menu_tplist.c
  SOURCES += $(APPPATH)/src/app_menu_tuner.c
  SOURCES += $(APPPATH)/src/app_menu_welcome.c
  SOURCES += $(APPPATH)/src/app_scaler.c
  
#  SOURCES += $(APPPATH)/src/app_ccir18.c
  
  
################################################################################

ifeq "$(TTXT_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_teletext.c

endif

ifneq "$(MHEG_PROFILE)" "0"

    SOURCES += $(APPPATH)/src/app_mheg.c

endif

ifeq "$(PVR_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_pvr.c
    SOURCES += $(APPPATH)/src/app_menu_playlist.c
    #SOURCES += $(APPPATH)/src/app_menu_editrec.c

endif

ifeq "$(CI_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_menu_ci.c

else
ifeq "$(CA_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_menu_ci.c

endif
endif

ifeq "$(RECTIMER_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_menu_timerprog.c
    SOURCES += $(APPPATH)/src/app_menu_timeredit.c

endif

ifeq "$(FESAT_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_menu_satinsttype.c
    SOURCES += $(APPPATH)/src/app_menu_satlist.c
    SOURCES += $(APPPATH)/src/app_satellites.c

endif

ifeq "$(DISEQC12_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_menu_motor.c

endif

ifeq "$(PARENTAL_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_menu_password.c

endif

ifeq "$(FILEOP_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_menu_viewer.c
    SOURCES += $(APPPATH)/src/app_menu_media.c

endif

ifeq "$(JPEG_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_menu_jpeg.c

endif

ifeq "$(MP3_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_menu_mp3.c

endif

ifeq "$(UPDATE_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_menu_update.c

endif

ifeq "$(OAD_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_menu_oad_scan.c

endif

ifeq "$(HDD_ENABLED)" "YES"
  SOURCES += $(APPPATH)/src/app_menu_hdd.c
else
    # this file is needed for USB devices too.
    ifeq "$(USB_ENABLED)" "YES"
      SOURCES += $(APPPATH)/src/app_menu_hdd.c
    endif
endif

################################################################################

ifeq "$(MOSAIC_ENABLED)" "YES"

    SOURCES      += $(APPPATH)/src/app_mosaic.c
    
    CCFLAGS_USER += -DAPPL_MOSAIC_ENABLED
    
    DOC_SECTION  += DOXYGEN_SMARTGO_MOSAIC

endif

ifeq "$(TTF_ENABLED)" "YES"

    CCFLAGS_USER += -DAPPL_TTF_ENABLED
    
    LIBRARIES    += freetype2
    LIBRARIES    += ftf
    LIBRARIES    += fontserver_engine_ft
    
    DOC_SECTION  += DOXYGEN_SMARTGO_TTF

endif

ifeq "$(BMP_SCALER_ENABLED)" "YES"

    CCFLAGS_USER += -DAPPL_BMP_SCALER_ENABLED
    
    DOC_SECTION  += DOXYGEN_SMARTGO_BMP_SCALER

endif

ifeq "$(FILEUPDATE_ENABLED)" "YES"

    CCFLAGS_USER += -DAPPL_FILEUPDATE_ENABLED

endif

ifeq "$(ETHERNET_ENABLED)" "YES"

    SOURCES += $(APPPATH)/src/app_menu_network.c
    SOURCES += $(APPPATH)/src/app_menu_network_ip.c
    SOURCES += $(APPPATH)/src/app_menu_network_dns.c
#    SOURCES += $(APPPATH)/src/app_menu_network_proxy.c
    SOURCES += $(APPPATH)/src/app_menu_network_info.c

endif

################################################################################

ifeq "$(DOC_ALL)" "YES"

    DOC_SECTION   += DOXYGEN_SMARTGO_MOSAIC
    DOC_SECTION   += DOXYGEN_SMARTGO_TTF
    DOC_SECTION   += DOXYGEN_SMARTGO_BMP_SCALER

endif

################################################################################

  RELEASE_ADDON_LOCAL_FILES  += $(wildcard $(APPPATH)/inc/*)
  RELEASE_ADDON_LOCAL_FILES  += $(APPPATH)/res/bmp_dat/symbUpdateSmall.dat
  RELEASE_ADDON_LOCAL_FILES  += $(wildcard $(APPPATH)/res/bmp_fbm/*)
  RELEASE_ADDON_LOCAL_FILES  += $(APPPATH)/res/font_ttf/FJ_Symbol_Bold.ftf
  RELEASE_ADDON_LOCAL_FILES  += $(APPPATH)/res/216_col.clt
  RELEASE_ADDON_LOCAL_FILES  += $(APPPATH)/res/english.lng
  RELEASE_ADDON_LOCAL_FILES  += $(APPPATH)/res/french.lng
  RELEASE_ADDON_LOCAL_FILES  += $(APPPATH)/res/german.lng
  RELEASE_ADDON_LOCAL_FILES  += $(APPPATH)/res/all_language.xls
  RELEASE_ADDON_LOCAL_FILES  += $(APPPATH)/res/fujitsu.fmv
  RELEASE_ADDON_LOCAL_FILES  += $(APPPATH)/res/radiobkgr.fmv
