/*!
*****************************************************************************
**
** \file        ./applications/smartgo-hd/fgs/inc/fgs_item_select.h
**
**              $Id: fgs_item_select.h 5866 2010-03-02 12:09:31Z jmorha $ 
**
** \brief       content description.
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/
#ifndef _FGS_ITEM_SELECT_H_
#define _FGS_ITEM_SELECT_H_

#include "fgs_list.h"


/*---------------------------------------------------------------------------*/
/* constants and macros                                                      */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* types, enums and structures                                               */
/*---------------------------------------------------------------------------*/

typedef struct
{
    FGS_ITEM_DRAWIF_S gfx;         //!< mandatory
    
} FGS_ITEM_SEL_INIT_S;

typedef struct
{
    uint32_t                numItems;         //!< number of available sub-indexes
    uint32_t                index;            //!< initial list index
    
} FGS_ITEM_SEL_PARAMS_S;

typedef struct
{
    FGS_POS_S             pos;           //!< item area rectangle
    uint32_t                   bkgrType;      //!< background type
    
    FGS_POS_S             descrPos;      //!< description position in item area
    FGS_POS_S             valuePos;      //!< value position in item area
    
    FGS_ITEM_SEL_PARAMS_S params;
    
} FGS_ITEM_SEL_OPEN_S;

typedef struct
{
    FGS_ITEM_SEL_OPEN_S  data;
    FGS_LIST_MEMBER_S*   pMem;          //!< pointer to own member structure
    
} FGS_ITEM_SEL_INST_S;

/*---------------------------------------------------------------------------*/
/* function prototypes                                                       */
/*---------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int32_t  FGS_ITEM_SEL_Init          (FGS_ITEM_SEL_INIT_S* pInitParams);
int32_t  FGS_ITEM_SEL_Open          (FGS_ITEM_SEL_OPEN_S* pData, int32_t id,
                                  FAPI_SYS_HandleT parent, FAPI_SYS_HandleT* ph);

#ifdef __cplusplus
}
#endif

#endif /* _FGS_ITEM_SELECT_H_ */
/******************************************************************************/
/* END OF FILE */
