/*!
*****************************************************************************
**
** \file        ./applications/smartgo-hd/sys/inc/eit.h
**
**              $Id: eit.h 5866 2010-03-02 12:09:31Z jmorha $
**
** \brief       EIT database module.
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/
#ifndef _EIT_H_
#define _EIT_H_

#include "sys_api.h"

/*---------------------------------------------------------------------------*/
/* constants and macros                                                      */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* types, enums and structures                                               */
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/* function prototypes                                                       */
/*---------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int32_t  EIT_Init                (void);
int32_t  EIT_FilteringStart      (SLIST_SERVIDX servIdx, uint16_t service_id);
int32_t  EIT_FilteringStop       (void);
int32_t  EIT_InvalidateService   (SLIST_SERVIDX servIdx);
int32_t  EIT_RequestNewEvents    (const SYS_SERVLOC_S* pServLoc);

#ifdef __cplusplus
}
#endif

#endif /* _EIT_H_ */

/******************************************************************************/
/* END OF FILE */
