/*!
*****************************************************************************
**
** \file        ./applications/smartgo-hd/sys/inc/fcdata.h
**
**              $Id: fcdata.h 5866 2010-03-02 12:09:31Z jmorha $
**
** \brief       API for flash-sparing storage of data frequently-changed during 
**              runtime.
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/
#ifndef _FCDATA_H_
#define _FCDATA_H_

#include "sys_api.h"

/*---------------------------------------------------------------------------*/
/* constants and macros                                                      */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* types, enums and structures                                               */
/*---------------------------------------------------------------------------*/

typedef struct
{
    SYS_SERVLOC_S            servLoc;
    uint8_t                  audioLvlLeft;
    uint8_t                  audioLvlRight;
    uint16_t                 reserved;
    
} FCDATA_ENTRY_S;

/*---------------------------------------------------------------------------*/
/* function prototypes                                                       */
/*---------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int32_t FCDATA_Init       (void);
int32_t FCDATA_StoreEntry (const FCDATA_ENTRY_S* pEntry);
int32_t FCDATA_GetEntry   (FCDATA_ENTRY_S* pEntry);

#ifdef __cplusplus
}
#endif

#endif /* _FCDATA_H_ */

/******************************************************************************/
/* END OF FILE */
