/*!
*****************************************************************************
**
** \file        ./applications/smartgo-hd/sys/inc/scart.h
**
**              $Id: scart.h 5866 2010-03-02 12:09:31Z jmorha $
**
** \brief       Internal SCART control functions.
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/
#ifndef _SCART_H_
#define _SCART_H_

#include "sys_api.h"

typedef enum
{
    SCART_MODE_OFF = 0,
    SCART_MODE_4_3,
    SCART_MODE_16_9
    
} SCART_MODE_E;

#ifdef __cplusplus
extern "C" {
#endif

SCART_MODE_E SCART_GetMode        (void);
void         SCART_SetMode        (SCART_MODE_E  mode);
void         SCART_SetVideoOutput (SYS_VIDEO_OUT mode);
void         SCART_SetOutputSource(fbool_t vcr);

#ifdef __cplusplus
}
#endif

#endif /* _SCART_H_ */

/******************************************************************************/
/* END OF FILE */
