/*!
*****************************************************************************
**
** \file        ./applications/smartgo-hd/sys/inc/settings.h
**
**              $Id: settings.h 5866 2010-03-02 12:09:31Z jmorha $
**
** \brief       Internal user settings management functions.
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/
#ifndef _SETTINGS_H_
#define _SETTINGS_H_

#include "sys_api.h"

#ifdef __cplusplus
extern "C" {
#endif

int32_t             SETTINGS_StartupInit        (void);
int32_t             SETTINGS_Init               (void);
void                SETTINGS_StartupDefaultsSet (void);
int32_t             SETTINGS_AspectRatioSet     (void);
int32_t             SETTINGS_ScaleMethodSet     (void);

#ifdef APPL_RFMOD_ENABLED

int32_t             SETTINGS_SetRfModParams (const RFMOD_EXCHG_PARAMS_S* params);
int32_t             SETTINGS_GetRfModParams (RFMOD_EXCHG_PARAMS_S* params);

#endif /* APPL_RFMOD_ENABLED */

#ifdef __cplusplus
}
#endif

#endif /* _SETTINGS_H_ */

/******************************************************************************/
/* END OF FILE */
