/*!
*****************************************************************************
**
** \file        ./applications/smartgo-hd/sys/inc/subtitle.h
**
**              $Id: subtitle.h 5866 2010-03-02 12:09:31Z jmorha $
**
** \brief       Internal DVB Subtitle management functions.
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/
#ifndef _SUBTITLE_H
#define _SUBTITLE_H

#ifdef APPL_SUBTT_ENABLED

#include "sys_priv.h"

/*----------------------------------------------------------------------*/
/* include files                                                        */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/* Definition of  structures                                            */
/*----------------------------------------------------------------------*/


/*----------------------------------------------------------------------*/
/* function prototypes                                                  */
/*----------------------------------------------------------------------*/
#ifdef __cplusplus
extern "C" {
#endif

int32_t  SUBTT_Init                   (const SUBTT_INIT_PARAMS_S* params);
void     SUBTT_Clear                  (void);
int32_t  SUBTT_PmtUpdate              (const PSISI_PMT_S* pPmt,
                                       fbool_t (*pidAvailable)(uint16_t pid));
void     SUBTT_Enable                 (fbool_t enable, SYS_SUSPENDSRC src);

#ifdef __cplusplus
}
#endif

#endif /* APPL_SUBTT_ENABLED */

#endif /*End of _SUBTITLE_H */

/******************************************************************************/
/* END OF FILE */
