/*!
*****************************************************************************
**
** \file        ./applications/smartgo-hd/sys/inc/sys_time.h
**
**              $Id: sys_time.h 5866 2010-03-02 12:09:31Z jmorha $
**
** \brief       Internal System time and timer management functions.
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/
#ifndef _SYS_TIME_H_
#define _SYS_TIME_H_

#include "sys_api.h"

#ifdef __cplusplus
extern "C" {
#endif

int32_t         TIME_Init             (void);
int32_t         TIME_SetSystemTime    (uint32_t time);

void            TIME_Sync             (uint32_t utc, uint16_t mjd);
int32_t         TIME_ForceEvtUpdate   (void);
void            TIME_TimeZoneChange   (uint32_t currUtc, uint16_t currMjd,
                                       uint32_t changeUtc, uint16_t changeMjd,
                                       int16_t thisTimeOffset,
                                       int16_t nextTimeOffset);

void            TIME_ConvertUTC       (uint32_t utc, SYS_TIME_S* pTime);
void            TIME_ConvertMJD       (uint16_t mjd, SYS_DATE_S* pDate);

int32_t         TIME_SingleTimerClose (uint8_t timerNum);

#ifdef __cplusplus
}
#endif

#endif /* _SYS_TIME_H_ */

/******************************************************************************/
/* END OF FILE */
