/*!
*****************************************************************************
**
** \file        ./applications/smartgo-hd/sys/inc/teletext.h
**
**              $Id: teletext.h 5866 2010-03-02 12:09:31Z jmorha $
**
** \brief       Internal API for embedded teletext module.
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/
#ifndef _TELETEXT_H_
#define _TELETEXT_H_

#include "fapex/abst_types.h"

#include "sys_api.h"
#include "sys_priv.h"

#ifdef APPL_TTXT_ENABLED

#define LEVEL_15

int32_t  TTX_Init                (const TTX_INIT_PARAMS_S* params);
void     TTX_Reset               (FAPI_SYS_HandleT ttxVbiHandle);
void     TTX_Shutdown            (void);
int32_t  TTX_IntShow             (uint16_t pageNumber);
int32_t  TTX_IntHide             (void);

void     TTXSUBTT_Enable         (fbool_t enable, SYS_SUSPENDSRC src);
int32_t  TTXSUBTT_SetTtxMode     (fbool_t enable);

#endif /* APPL_TTXT_ENABLED */

/* Teletext subtitle internal API */
int32_t  TTXSUBTT_Init          (void);
void     TTXSUBTT_Clear         (void);
int32_t  TTXSUBTT_PmtUpdate     (const PSISI_PMT_S* pPmt,
                                 fbool_t (*pidAvailable)(uint16_t pid));

#endif /* _TELETEXT_H_ */

/******************************************************************************/
/* END OF FILE */
