/*!
*****************************************************************************
**
** \file        ./applications/smartgo-hd/sys/inc/usals.h
**
**              $Id: usals.h 5866 2010-03-02 12:09:31Z jmorha $
**
** \brief       
**
** \attention   THIS SAMPLE CODE IS PROVIDED AS IS. FUJITSU SEMICONDUCTOR
**              ACCEPTS NO RESPONSIBILITY OR LIABILITY FOR ANY ERRORS OR
**              OMMISSIONS.
**
** (C) Copyright 2006-2010 by Fujitsu Semiconductor Europe GmbH
**
*****************************************************************************
*/
#ifndef _USALS_H_
#define _USALS_H_

#include "sys_api.h"

/*---------------------------------------------------------------------------*/
/* constants and macros                                                      */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/* types, enums and structures                                               */
/*---------------------------------------------------------------------------*/

typedef struct
{
    SYS_GEO_POS_S       geoPos;         //!< local geographical position

} USALS_PARAMS_S;

typedef struct
{
    FAPI_SYS_HandleT    feHdl;          //!< Frontend driver handle.
    uint8_t             motorAddress;   //!< DiSEqC adress byte.

} USALS_OPEN_PARAMS_S;

/*---------------------------------------------------------------------------*/
/* function prototypes                                                       */
/*---------------------------------------------------------------------------*/

#ifdef __cplusplus
extern "C"
{
#endif

int32_t USALS_Init              (void);
void    USALS_Exit              (void);
int32_t USALS_Open              (USALS_OPEN_PARAMS_S * openParams,
                                 FAPI_SYS_HandleT * pUsalsHdl);
int32_t USALS_Close             (FAPI_SYS_HandleT usalsHdl);
int32_t USALS_RestoreDefaults   (void);
int32_t USALS_CalcRealAngle     (const SYS_ORBPOS_S * abspos,
                                 SYS_ORBPOS_S * realPos);
int32_t USALS_GotoPos           (FAPI_SYS_HandleT usalsHdl,
                                 const SYS_ORBPOS_S * orbpos);
int32_t USALS_GotoPosZero       (FAPI_SYS_HandleT usalsHdl);

#ifdef __cplusplus
}
#endif

#endif /* _USALS_H_ */

/******************************************************************************/
/* END OF FILE */
